"/
"/ execute this script using the following command line:
"/
"/ stx --noBanner -I --execute SelfTest.st
"/
"/ to use with jenkins (+ perfPublisher plugin):
"/ use the following buildscript (in jenkins):
"/ (after checkout of stx)
"/      cd stx
"/      call bmake
"/      cd goodies\selftest
"/      ..\..\projects\smalltalk\stx.com --noBanner -I --execute SelfTest.st
"/
"/ and configure the perfPublisher jenkins plugin, to scan for "testresult.xml"

Object infoPrinting:false.
ObjectMemory infoPrinting:false.
Processor activeProcess exceptionHandlerSet
    on:(Class updateChangeFileQuerySignal)
    do:[:ex | ex proceedWith:false ].
!

Stdout showCR:'Selftest Started'.
!

Stdout showCR:'Loading sunit...'.
Smalltalk loadPackage:'stx:goodies/sunit'.
!

Smalltalk loadPackage:'stx:goodies/xml/vw'.
Smalltalk loadPackage:'stx:goodies/xml/stx'.
!

Stdout showCR:'Loading regression tests...'.
Smalltalk installAutoloadedClassesFromAbbrevFile:((Smalltalk projectDirectoryForPackage:'exept:regression') asFilename / 'abbrev.stc').
(Smalltalk allClassesInPackage:'exept:regression') do:[:each |
    (#(
	'RegressionTests::ExternalInterfaceTests'
	'RegressionTests::ContextTest2'
    ) includes:each name) ifTrue:[
	Stdout showCR:('Skipped ',each name,'...').
    ] ifFalse:[
	Stdout showCR:('Loading ',each name,'...').
	each autoload
    ].
].
!

|suite result|

Stdout showCR:'Creating suite...'.
suite := TestSuite named:'SelfTest'.
"/ suite addTest:(RegressionTests::QuickTest suite).
suite addTest:(RegressionTests::AssociationTests suite).
suite addTest:(RegressionTests::BinaryIOTests suite).
suite addTest:(RegressionTests::BinaryTreeTester suite).
suite addTest:(RegressionTests::BlockTest suite).
suite addTest:(RegressionTests::CharacterTests suite).
suite addTest:(RegressionTests::CollectionTests suite).
suite addTest:(RegressionTests::CompilerTest suite).
suite addTest:(RegressionTests::ComplexTest suite).
"/ suite addTest:(RegressionTests::DebuggerTest suite).
suite addTest:(RegressionTests::DeepCopyTests suite).
suite addTest:(RegressionTests::DelayTest suite).
suite addTest:(RegressionTests::DictionaryTest suite).
suite addTest:(RegressionTests::EnumerationTests suite).
suite addTest:(RegressionTests::ExceptionTest suite).
"/ suite addTest:(RegressionTests::ExternalInterfaceTests suite).
suite addTest:(RegressionTests::FileOpenTest suite).
suite addTest:(RegressionTests::FileStreamTest suite).
suite addTest:(RegressionTests::FloatTest suite).
suite addTest:(RegressionTests::FractionTest suite).
suite addTest:(RegressionTests::FractionTest suite).
suite addTest:(RegressionTests::GCTest suite).
suite addTest:(RegressionTests::GraphicDrawingTest suite).
suite addTest:(RegressionTests::HTMLParserTests suite).
suite addTest:(RegressionTests::ImageReaderTest suite).
suite addTest:(RegressionTests::IntegerTest suite).
suite addTest:(RegressionTests::JavaScriptTests suite).
"/ suite addTest:(RegressionTests::MeasurementValueTests suite).
suite addTest:(RegressionTests::MemoryTest suite).
suite addTest:(RegressionTests::NumberTest suite).
suite addTest:(RegressionTests::ParserTest suite).
suite addTest:(RegressionTests::ScaledDecimalTest suite).
suite addTest:(RegressionTests::SemaphoreTest suite).
suite addTest:(RegressionTests::SharedQueueTest suite).
suite addTest:(RegressionTests::SmallIntegerTest suite).
suite addTest:(RegressionTests::SortTests suite).
suite addTest:(RegressionTests::StringTests suite).
suite addTest:(RegressionTests::TimeAndDateTest suite).
suite addTest:(RegressionTests::TimeDurationTest suite).
suite addTest:(RegressionTests::URLTest suite).
suite addTest:(RegressionTests::XMLCoderTests suite).
suite addTest:(RegressionTests::ZipArchiveTests suite).

Stdout showCR:'Running suite...'.
result := suite
	    runBeforeEachDo:[:test |
		Stdout showCR:('- running ',test printString).
	    ].
TestResultReporter
    report:result
    format:#xml_perfPublisher
    as:'testresult.xml'.
!
